commit 7b30a12edf7a3a461bbfc9cbb29b3050c7164032
Author: Daniel Cederman <cederman@gaisler.com>
Date:   Mon Oct 12 08:50:35 2020

    sparc: Prevent atomic instructions in beginning of functions for UT700
    
    A call to the function might have a load instruction in the delay slot
    and a load followed by an atomic function could cause a deadlock.
    
    gcc/ChangeLog:
    
            * config/sparc/sparc.c (sparc_do_work_around_errata): Do not begin
            functions with atomic instruction in the UT700 errata workaround.

diff --git a/gcc/config/sparc/sparc.c b/gcc/config/sparc/sparc.c
index 2487caf72da..6f419f6fd58 100644
--- a/gcc/config/sparc/sparc.c
+++ b/gcc/config/sparc/sparc.c
@@ -1124,6 +1124,7 @@ static unsigned int
 sparc_do_work_around_errata (void)
 {
   rtx_insn *insn, *next;
+  bool find_first_useful = true;
 
   /* Force all instructions to be split into their final form.  */
   split_all_insns_noflow ();
@@ -1148,6 +1149,16 @@ sparc_do_work_around_errata (void)
       else
 	jump = NULL;
 
+      /* Do not begin function with atomic instruction.  */
+      if (sparc_fix_ut700
+	  && find_first_useful
+	  && USEFUL_INSN_P (insn))
+	{
+	  find_first_useful = false;
+	  if (atomic_insn_for_leon3_p (insn))
+	    emit_insn_before (gen_nop (), insn);
+	}
+
       /* Place a NOP at the branch target of an integer branch if it is a
 	 floating-point operation or a floating-point branch.  */
       if (sparc_fix_gr712rc

